atkmm 2.36.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Atk::Relation Class Reference

An Atk::Relation describes a relation between an object and one or more other objects. More...

`#include <atkmm/relation.h>`

Inheritance diagram for Atk::Relation:
[legend]

## Public Types
enum class | Type { NONE , CONTROLLED_BY , CONTROLLER_FOR , LABEL_FOR , LABELLED_BY , MEMBER_OF , NODE_CHILD_OF , FLOWS_TO , FLOWS_FROM , SUBWINDOW_OF , EMBEDS , EMBEDDED_BY , POPUP_FOR , PARENT_WINDOW_OF , DESCRIBED_BY , DESCRIPTION_FOR , NODE_PARENT_OF , DETAILS , DETAILS_FOR , ERROR_MESSAGE , ERROR_FOR , LAST_DEFINED }
| Describes the type of the relation. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)

## Public Member Functions
| Relation (Relation&& src) noexcept
Relation& | operator= (Relation&& src) noexcept
| ~Relation () noexcept override
AtkRelation* | gobj ()
| Provides access to the underlying C GObject. More...
const AtkRelation* | gobj () const
| Provides access to the underlying C GObject. More...
AtkRelation* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Type | get_relation_type () const
| Gets the type of relation. More...
std::vector< Glib::RefPtr< Atk::Object > > | get_target ()
std::vector< Glib::RefPtr< const Atk::Object > > | get_target () const
void | add_target (const Glib::RefPtr< Atk::Object >& target)
| Adds the specified AtkObject to the target for the relation, if it is not already present. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Relation > | create (const std::vector< Glib::RefPtr< Atk::Object >>& targets, Type relationship=Type::NONE)

## Protected Member Functions
| Relation (const std::vector< Glib::RefPtr< Atk::Object >>& targets, Relation::Type relationship)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Atk::Relation > | wrap (AtkRelation* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

An Atk::Relation describes a relation between an object and one or more other objects.

The actual relations that an object has with other objects are defined as an Atk::RelationSet, which is a set of Atk::Relations.

## Constructor & Destructor Documentation

## ◆ Relation() [1/2]

Atk::Relation::Relation | ( | Relation&& | src | ) |
| noexcept

## ◆ ~Relation()

Atk::Relation::~Relation | ( |  | ) |
| override noexcept

## ◆ Relation() [2/2]

Atk::Relation::Relation | ( | const std::vector< Glib::RefPtr< Atk::Object >>& | targets,
|  | Relation::Type | relationship
| ) |  |
| explicit protected

## Member Function Documentation

## ◆ add_target()

void Atk::Relation::add_target | ( | const Glib::RefPtr< Atk::Object >& | target | ) |

Adds the specified AtkObject to the target for the relation, if it is not already present.

See also Atk::Object::add_relationship().

Since atkmm 1.9:

Parameters

  target | An Atk::Object.

## ◆ create()

static Glib::RefPtr<Relation> Atk::Relation::create | ( | const std::vector< Glib::RefPtr< Atk::Object >>& | targets,
|  | Type | relationship = `Type::NONE`
| ) |  |
| static

## ◆ get_relation_type()

Type Atk::Relation::get_relation_type | ( |  | ) | const

Gets the type of relation.

Returns
  The type of relation.

## ◆ get_target() [1/2]

std::vector<Glib::RefPtr<Atk::Object> > Atk::Relation::get_target | ( |  | ) |

## ◆ get_target() [2/2]

std::vector<Glib::RefPtr<const Atk::Object> > Atk::Relation::get_target | ( |  | ) | const

## ◆ get_type()

static GType Atk::Relation::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

AtkRelation* Atk::Relation::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const AtkRelation* Atk::Relation::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

AtkRelation* Atk::Relation::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

Relation& Atk::Relation::operator= | ( | Relation&& | src | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Atk::Relation > wrap | ( | AtkRelation * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.